package modele;

import java.awt.Color;
import java.util.Iterator;
import java.util.LinkedList;

public abstract class Figure extends LinkedList<Point> implements Operable {
    public class ChangementDEpaisseur {
        private int index;
        private int epaisseur;
        public ChangementDEpaisseur(int index, int epaisseur) {
            this.index = index;
            this.epaisseur = epaisseur;
        }
        public int index() {
            return index;
        }
        public int epaisseur() {
            return epaisseur;
        }
    }
    public class ChangementDeCouleur {
        private int index;
        private Color couleur;
        public ChangementDeCouleur(int index, Color couleur) {
            this.index = index;
            this.couleur = couleur;
        }
        public int index() {
            return index;
        }
        public Color couleur() {
            return couleur;
        }
    }
    private LinkedList<ChangementDEpaisseur> epaisseurs;
    private LinkedList<ChangementDeCouleur> couleurs;
    public Figure(int epaisseur, Color couleur) {
        epaisseurs = new LinkedList<ChangementDEpaisseur>();
        epaisseurs.add(new ChangementDEpaisseur(0, epaisseur));
        couleurs = new LinkedList<ChangementDeCouleur>();
        couleurs.add(new ChangementDeCouleur(0, couleur));
    }
    public Iterator<ChangementDEpaisseur> iterateurChangmtEpaisseur() {
        return epaisseurs.iterator();
    }
    public Iterator<ChangementDeCouleur> iterateurChangmtCouleur() {
        return couleurs.iterator();
    }
    public void changementDEpaisseur(int ep) {
        epaisseurs.add(new ChangementDEpaisseur(size(), ep));
    }
    public void changementDeCouleur(Color coul) {
        couleurs.add(new ChangementDeCouleur(size(), coul));
    }
}
