package vue;

import modele.*;
import modele.Point;

import java.awt.*;
import java.util.Iterator;

public class Affichage implements Operation {
    private Graphics g;
    public Affichage(Graphics contexteGrahique) {
        g = contexteGrahique;
    }
    public void opereSur(Dessin d) {
        for (Figure f : d) f.realise(this);
    }
    public void opereSur(Trace t) {
        Point p1, p2;
        int index;
        Iterator<Point> it = t.iterator();
        Iterator<Figure.ChangementDEpaisseur> itep = t.iterateurChangmtEpaisseur();
        Iterator<Figure.ChangementDeCouleur> itcoul = t.iterateurChangmtCouleur();
        p1 = it.next();
        index = 0;
        Figure.ChangementDEpaisseur chep = itep.next();
        ((Graphics2D)g).setStroke(new BasicStroke(chep.epaisseur(), BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND));
        if (itep.hasNext()) chep = itep.next();
        Figure.ChangementDeCouleur chcoul = itcoul.next();
        g.setColor(chcoul.couleur());
        if (itcoul.hasNext()) chcoul = itcoul.next();
        while(it.hasNext()) {
            p2 = it.next();
            index++;
            g.drawLine(p1.getX(), p1.getY(), p2.getX(), p2.getY());
            if (index == chep.index()) {
                ((Graphics2D) g).setStroke(new BasicStroke(chep.epaisseur(), BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND));
                if (itep.hasNext()) chep = itep.next();
            }
            if (index == chcoul.index()) {
                g.setColor(chcoul.couleur());
                if (itcoul.hasNext()) chcoul = itcoul.next();
            }
            p1 = p2;
        }
    }
    public void opereSur(Etoile e) {
        Point p1, p2;
        int index;
        Iterator<Point> it = e.iterator();
        Iterator<Figure.ChangementDEpaisseur> itep = e.iterateurChangmtEpaisseur();
        Iterator<Figure.ChangementDeCouleur> itcoul = e.iterateurChangmtCouleur();
        p1 = it.next();
        index = 0;
        Figure.ChangementDEpaisseur chep = itep.next();
        ((Graphics2D)g).setStroke(new BasicStroke(chep.epaisseur(), BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND));
        if (itep.hasNext()) chep = itep.next();
        Figure.ChangementDeCouleur chcoul = itcoul.next();
        g.setColor(chcoul.couleur());
        if (itcoul.hasNext()) chcoul = itcoul.next();
        while(it.hasNext()) {
            p2 = it.next();
            index++;
            g.drawLine(p1.getX(), p1.getY(), p2.getX(), p2.getY());
            if (index == chep.index()) {
                ((Graphics2D) g).setStroke(new BasicStroke(chep.epaisseur(), BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND));
                if (itep.hasNext()) chep = itep.next();
            }
            if (index == chcoul.index()) {
                g.setColor(chcoul.couleur());
                if (itcoul.hasNext()) chcoul = itcoul.next();
            }
        }
    }
}
