package vue;

import controleur.ControleurClavier;
import controleur.ControleurEtoile;
import controleur.ControleurSouris;
import controleur.ControleurTrace;
import modele.Dessin;
import modele.Figure;

import java.awt.*;
import javax.swing.JFrame;

public class FenetreDeDessin extends JFrame {
    private Dessin dessin;
    private int epaisseur;
    private Color couleur;
    private BasicStroke pinceau;
    private ControleurSouris controleurTrace, controleurEtoile, controleurCourant;
    public FenetreDeDessin(ControleurClavier contrClavier, Dessin modele) {
        dessin = modele;
        setTitle("Une première fenêtre pour dessiner à main levée");
        setSize(600, 500);
        setLocationRelativeTo(null);
        setDefaultCloseOperation(EXIT_ON_CLOSE);
        controleurTrace = new ControleurTrace(this, dessin);
        controleurEtoile = new ControleurEtoile(this, dessin);
        controleurCourant = controleurTrace;
        addMouseListener(controleurCourant);
        addMouseMotionListener(controleurCourant);
        addKeyListener(contrClavier);
        contrClavier.pour(dessin, this);
        changeEpaisseur(1);
        changeCouleur(Color.black);
        setVisible(true);
    }
    public void changeEpaisseur(int ep) {
        epaisseur = ep;
        pinceau = new BasicStroke(ep, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND);
    }
    public int epaisseur() {
        return epaisseur;
    }
    public void changeCouleur(Color coul) {
        couleur = coul;
    }
    public Color couleur() { return couleur; }
    public void dessineSegment(int x1, int y1, int x2, int y2) {
        Graphics g = getGraphics();
        ((Graphics2D)g).setStroke(pinceau);
        g.setColor(couleur);
        g.drawLine(x1, y1, x2, y2);
    }
    private void changePourControleur(ControleurSouris controleurChoisi) {
        removeMouseListener(controleurCourant);
        removeMouseMotionListener(controleurCourant);
        controleurCourant = controleurChoisi;
        addMouseListener(controleurCourant);
        addMouseMotionListener(controleurCourant);
    }
    public void outilTrace() {
        changePourControleur(controleurTrace);
    }
    public void outilEtoile() {
        changePourControleur(controleurEtoile);
    }
    public void paint(Graphics g) {
        g.setColor(Color.white);
        g.fillRect(0, 0, this.getWidth(), this.getHeight());
        dessin.realise(new Affichage(g));
    }
}
